Index: c/src/lib/libbsp/mips/jmr3904/ChangeLog
===================================================================
--- c/src/lib/libbsp/mips/jmr3904/ChangeLog	(revision 2ba9d3bdcc7a4407706cb3860706cc3d82794c38)
+++ c/src/lib/libbsp/mips/jmr3904/ChangeLog	(revision 8f81248cb7168a0331b3417ea61c285d2a09906b)
@@ -1,2 +1,8 @@
+2000-12-19	Joel Sherrill <joel@OARcorp.com>
+
+	* timer: New subdirectory.
+	* timer/.cvsignore, timer/Makefile.am, timer/timer.c: New files.
+	* tools/ChangeLog: New file.
+
 2000-12-19	Joel Sherrill <joel@OARcorp.com>
 
Index: c/src/lib/libbsp/mips/jmr3904/timer/.cvsignore
===================================================================
--- c/src/lib/libbsp/mips/jmr3904/timer/.cvsignore	(revision 8f81248cb7168a0331b3417ea61c285d2a09906b)
+++ c/src/lib/libbsp/mips/jmr3904/timer/.cvsignore	(revision 8f81248cb7168a0331b3417ea61c285d2a09906b)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: c/src/lib/libbsp/mips/jmr3904/timer/Makefile.am
===================================================================
--- c/src/lib/libbsp/mips/jmr3904/timer/Makefile.am	(revision 8f81248cb7168a0331b3417ea61c285d2a09906b)
+++ c/src/lib/libbsp/mips/jmr3904/timer/Makefile.am	(revision 8f81248cb7168a0331b3417ea61c285d2a09906b)
@@ -0,0 +1,33 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+
+PGM = $(ARCH)/timer.rel
+
+C_FILES = timer.c
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+
+OBJS = $(C_O_FILES)
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
+include $(top_srcdir)/../../../../../../automake/lib.am
+
+#
+# (OPTIONAL) Add local stuff here using +=
+#
+
+$(PGM): $(OBJS)
+	$(make-rel)
+
+# the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
+
+all-local: $(ARCH) $(OBJS) $(PGM)
+
+.PRECIOUS: $(PGM)
+
+EXTRA_DIST = timer.c
+
+include $(top_srcdir)/../../../../../../automake/local.am
Index: c/src/lib/libbsp/mips/jmr3904/timer/timer.c
===================================================================
--- c/src/lib/libbsp/mips/jmr3904/timer/timer.c	(revision 8f81248cb7168a0331b3417ea61c285d2a09906b)
+++ c/src/lib/libbsp/mips/jmr3904/timer/timer.c	(revision 8f81248cb7168a0331b3417ea61c285d2a09906b)
@@ -0,0 +1,74 @@
+/* 
+ *  This file implements a benchmark timer using a TX39 timer.
+ *
+ *  NOTE: On the simulator, the count directly reflects instructions.
+ *
+ *  COPYRIGHT (c) 1989-2000.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <assert.h>
+
+#include <bsp.h>
+
+rtems_boolean Timer_driver_Find_average_overhead;
+
+void Timer_initialize()
+{
+  /*
+   *  Programming the compare register as the maximum value should let
+   *  it run long enough and accurate enough not to require an interrupt.
+   *  but if it ever does generate an interrupt, we will simply fault.
+   *
+   *  NOTE:  This is identical to the clock driver initialization
+   *         with the exception that the divider is disabled and
+   *         the compare register is set to the maximum value.
+   */
+
+  TX3904_TIMER_WRITE( TX3904_TIMER0_BASE, TX3904_TIMER_CCDR, 0x3 );
+  TX3904_TIMER_WRITE( TX3904_TIMER0_BASE, TX3904_TIMER_TRR, 0x0 );
+  TX3904_TIMER_WRITE( TX3904_TIMER0_BASE, TX3904_TIMER_CPRA, 0xFFFFFFFF );
+  TX3904_TIMER_WRITE( TX3904_TIMER0_BASE, TX3904_TIMER_TISR, 0x00 );
+  TX3904_TIMER_WRITE( TX3904_TIMER0_BASE, TX3904_TIMER_ITMR, 0x8001 );
+  TX3904_TIMER_WRITE( TX3904_TIMER0_BASE, TX3904_TIMER_TCR,   0xc0 );
+  *((volatile unsigned32 *) 0xFFFFC01C) = 0x00000700;
+}
+
+#define AVG_OVERHEAD      0  /* It typically takes 24 instructions */
+                             /*     to start/stop the timer. */
+#define LEAST_VALID       1  /* Don't trust a value lower than this */
+                             /* tx39 simulator can count instructions. :) */
+
+int Read_timer()
+{
+  rtems_unsigned32  total;
+
+  TX3904_TIMER_WRITE( TX3904_TIMER0_BASE, TX3904_TIMER_TCR,   0x03 );
+  total = TX3904_TIMER_READ( TX3904_TIMER0_BASE, TX3904_TIMER_TRR );
+
+  if ( Timer_driver_Find_average_overhead == 1 )
+    return total;          /* in one microsecond units */
+
+  if ( total < LEAST_VALID )
+    return 0;            /* below timer resolution */
+
+  return total - AVG_OVERHEAD;
+}
+
+rtems_status_code Empty_function( void )
+{
+  return RTEMS_SUCCESSFUL;
+}
+
+void Set_find_average_overhead(
+  rtems_boolean find_flag
+)
+{
+  Timer_driver_Find_average_overhead = find_flag;
+}
Index: c/src/lib/libbsp/mips/jmr3904/tools/ChangeLog
===================================================================
--- c/src/lib/libbsp/mips/jmr3904/tools/ChangeLog	(revision 8f81248cb7168a0331b3417ea61c285d2a09906b)
+++ c/src/lib/libbsp/mips/jmr3904/tools/ChangeLog	(revision 8f81248cb7168a0331b3417ea61c285d2a09906b)
@@ -0,0 +1,3 @@
+2000-12-19	Joel Sherrill <joel@OARcorp.com>
+
+	* ChangeLog: New file.
